defmodule Mv.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    Mv.Vereinfacht.SyncFlash.create_table!()

    children = [
      MvWeb.Telemetry,
      Mv.Repo,
      {Task.Supervisor, name: Mv.TaskSupervisor},
      {DNSCluster, query: Application.get_env(:mv, :dns_cluster_query) || :ignore},
      {Phoenix.PubSub, name: Mv.PubSub},
      {AshAuthentication.Supervisor, otp_app: :my},
      Mv.Helpers.SystemActor,
      # Start a worker by calling: Mv.Worker.start_link(arg)
      # {Mv.Worker, arg},
      # Start to serve requests, typically the last entry
      MvWeb.Endpoint
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Mv.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    MvWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
